local addonName, addonData = ...;

-- Store Local Copies of the Data for use with Resetting
local nUI_InfoPanel 	= addonData["nUI"].InfoPanel or false;
local nUI_BackGround 	= addonData["nUI"].BackGround.Enabled or false;

local SF_Movable 		= addonData["ScrollFrame"].Movable or false;
local SF_ScrollSize		= addonData["ScrollFrame"].ScrollSize;
local SF_Width			= addonData["ScrollFrame"].Width;
local SF_Height			= addonData["ScrollFrame"].Height;
local SF_MainAnchor_Top	= addonData["ScrollFrame"].MainAnchor.Offset.Top or 0;
local SF_MainAnchor_Left= addonData["ScrollFrame"].MainAnchor.Offset.Left or 0;
local SF_BackGround		= addonData["ScrollFrame"].BackGround.Enabled or false;
	
local WF_CollapsedAnchor_Top 	= addonData["ScrollFrame"].MainAnchor.Offset.Top or 0;
local WF_CollapsedAnchor_Left 	= addonData["ScrollFrame"].MainAnchor.Offset.Left or 0;
local WF_ExpandedAnchor_Top 	= addonData["ScrollFrame"].MainAnchor.Offset.Top or 0;
local WF_ExpandedAnchor_Left 	= addonData["ScrollFrame"].MainAnchor.Offset.Left or 0;
local WF_MultipleAnchors 		= addonData["WatchFrame"].MultipleAnchors or false;
local WF_Collapsed 				= addonData["WatchFrame"].Collapsed or false;

addonData["Frames"] = addonData["Frames"] or {};
addonData["Frames"].SWF_SVFrame = nil;

SWF_Data 										= SWF_Data 										or {};
SWF_Data["nUI"] 								= SWF_Data["nUI"] 								or {};
SWF_Data["ScrollFrame"] 						= SWF_Data["ScrollFrame"] 						or {};
SWF_Data["ScrollFrame"].MainAnchor 				= SWF_Data["ScrollFrame"].MainAnchor 			or {};
SWF_Data["ScrollFrame"].MainAnchor.Offset 		= SWF_Data["ScrollFrame"].MainAnchor.Offset 	or {};
SWF_Data["ScrollFrame"].BackGround 				= SWF_Data["ScrollFrame"].BackGround 			or {};
SWF_Data["WatchFrame"] 							= SWF_Data["WatchFrame"] 						or {};
SWF_Data["WatchFrame"].CollapsedAnchor 			= SWF_Data["WatchFrame"].CollapsedAnchor 		or {};
SWF_Data["WatchFrame"].CollapsedAnchor.Offset 	= SWF_Data["WatchFrame"].CollapsedAnchor.Offset or {};
SWF_Data["WatchFrame"].ExpandedAnchor 			= SWF_Data["WatchFrame"].ExpandedAnchor 		or {};
SWF_Data["WatchFrame"].ExpandedAnchor.Offset 	= SWF_Data["WatchFrame"].ExpandedAnchor.Offset 	or {};

addonData["SavedVars"] = {};

addonData["SavedVars"].Create = function()
	SWF_Data = {};
	SWF_Data["nUI"] = {};
	SWF_Data["ScrollFrame"] = {};
	SWF_Data["ScrollFrame"].MainAnchor = {};
	SWF_Data["ScrollFrame"].MainAnchor.Offset = {};
	SWF_Data["ScrollFrame"].BackGround = {};
	SWF_Data["WatchFrame"] = {};
	SWF_Data["WatchFrame"].CollapsedAnchor		= {};
	SWF_Data["WatchFrame"].CollapsedAnchor.Offset		= {};
	SWF_Data["WatchFrame"].ExpandedAnchor		= {};
	SWF_Data["WatchFrame"].ExpandedAnchor.Offset		= {};

	SWF_Data["nUI"].InfoPanel 					= nUI_InfoPanel or false;
	SWF_Data["nUI"].BackGround 					= SWF_Data["nUI"].BackGround or {};
	SWF_Data["nUI"].BackGround.Enabled 			= nUI_BackGround or false;
	
	SWF_Data["ScrollFrame"].Movable 					= SF_Movable or false;
	SWF_Data["ScrollFrame"].ScrollSize 					= SF_ScrollSize;
	SWF_Data["ScrollFrame"].Width 						= SF_Width;
	SWF_Data["ScrollFrame"].Height 						= SF_Height;
	SWF_Data["ScrollFrame"].MainAnchor.Offset.Top 		= SF_MainAnchor_Top or 0;
	SWF_Data["ScrollFrame"].MainAnchor.Offset.Left 		= SF_MainAnchor_Left or 0;
	SWF_Data["ScrollFrame"].BackGround.Enabled 			= SF_BackGround or false;
	
	SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Top	= WF_CollapsedAnchor_Top or 0;
	SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Left	= WF_CollapsedAnchor_Left or 0;
	SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Top	= WF_ExpandedAnchor_Top or 0;
	SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Left	= WF_ExpandedAnchor_Left or 0;
	SWF_Data["WatchFrame"].MultipleAnchors				= WF_MultipleAnchors or false;
	SWF_Data["WatchFrame"].Collapsed					= WF_Collapsed or false;
end

addonData["SavedVars"].Load = function()

	addonData["nUI"].InfoPanel 					= SWF_Data["nUI"].InfoPanel or false;
	addonData["nUI"].BackGround.Enabled 		= SWF_Data["nUI"].BackGround.Enabled;

	addonData["ScrollFrame"].Movable 					= SWF_Data["ScrollFrame"].Movable or false;
	addonData["ScrollFrame"].ScrollSize 				= SWF_Data["ScrollFrame"].ScrollSize or SF_ScrollSize;
	addonData["ScrollFrame"].Width 						= SWF_Data["ScrollFrame"].Width or SF_Width;
	addonData["ScrollFrame"].Height 					= SWF_Data["ScrollFrame"].Height or SF_Height;
	addonData["ScrollFrame"].MainAnchor.Offset.Top 		= SWF_Data["ScrollFrame"].MainAnchor.Offset.Top or 0;
	addonData["ScrollFrame"].MainAnchor.Offset.Left 	= SWF_Data["ScrollFrame"].MainAnchor.Offset.Left or 0;
	addonData["ScrollFrame"].BackGround.Enabled 		= SWF_Data["ScrollFrame"].BackGround.Enabled or false;
	
	addonData["WatchFrame"].CollapsedAnchor.Offset.Top		= SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Top or 0;
	addonData["WatchFrame"].CollapsedAnchor.Offset.Left		= SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Left or 0;
	addonData["WatchFrame"].ExpandedAnchor.Offset.Top		= SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Top or 0;
	addonData["WatchFrame"].ExpandedAnchor.Offset.Left		= SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Left or 0;
	addonData["WatchFrame"].MultipleAnchors					= SWF_Data["WatchFrame"].MultipleAnchors or false;
	addonData["WatchFrame"].Collapsed						= SWF_Data["WatchFrame"].Collapsed or false;
end

addonData["SavedVars"].Reset = function()
	addonData["SavedVars"].Create();
	addonData["SavedVars"].Load();
end

addonData["SavedVars"].Save = function()

	SWF_Data["nUI"].InfoPanel 					= addonData["nUI"].InfoPanel or false;
	SWF_Data["nUI"].BackGround.Enabled 			= addonData["nUI"].BackGround.Enabled or false;

	SWF_Data["ScrollFrame"].Movable 					= addonData["ScrollFrame"].Movable or false;
	SWF_Data["ScrollFrame"].ScrollSize 					= addonData["ScrollFrame"].ScrollSize or SF_ScrollSize;
	SWF_Data["ScrollFrame"].Width 						= addonData["ScrollFrame"].Width or SF_Width;
	SWF_Data["ScrollFrame"].Height 						= addonData["ScrollFrame"].Height or SF_Height;
	SWF_Data["ScrollFrame"].MainAnchor.Offset.Top 		= addonData["ScrollFrame"].MainAnchor.Offset.Top or 0;
	SWF_Data["ScrollFrame"].MainAnchor.Offset.Left 		= addonData["ScrollFrame"].MainAnchor.Offset.Left or 0;
	SWF_Data["ScrollFrame"].BackGround.Enabled 			= addonData["ScrollFrame"].BackGround.Enabled or false;
	
	SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Top	= addonData["WatchFrame"].CollapsedAnchor.Offset.Top or 0;
	SWF_Data["WatchFrame"].CollapsedAnchor.Offset.Left	= addonData["WatchFrame"].CollapsedAnchor.Offset.Left or 0;
	SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Top	= addonData["WatchFrame"].ExpandedAnchor.Offset.Top or 0;
	SWF_Data["WatchFrame"].ExpandedAnchor.Offset.Left	= addonData["WatchFrame"].ExpandedAnchor.Offset.Left or 0;
	SWF_Data["WatchFrame"].MultipleAnchors				= addonData["WatchFrame"].MultipleAnchors or false;
	SWF_Data["WatchFrame"].Collapsed					= addonData["WatchFrame"].Collapsed or false;
end


local function onEvent()
	if event == "VARIABLES_LOADED" then
		addonData["SavedVars"].Load();
	elseif event == "PLAYER_LOGOUT" then
		addonData["SavedVars"].Save();	
	end	
end

-- Make sure the Saved Variables Table is created before we go any further
addonData["SavedVars"].Create();

addonData["Frames"].SWF_SVFrame    = CreateFrame( "Frame", "SWF_SVFrame", UIParent );
addonData["Frames"].SWF_SVFrame:SetScript( "OnEvent", onEvent );
addonData["Frames"].SWF_SVFrame:RegisterEvent( "VARIABLES_LOADED" );
addonData["Frames"].SWF_SVFrame:RegisterEvent( "PLAYER_LOGOUT" );
