local addonName, addonData = ...;

addonData["WatchFrame"] = {};

addonData["WatchFrame"].CollapsedAnchor = {
	Offset = { Top = 0, Left = 0 },
};

addonData["WatchFrame"].ExpandedAnchor = {
	Offset = { Top = 0, Left = 0 },
};

addonData["WatchFrame"].MultipleAnchors = false;
addonData["WatchFrame"].Collapsed = false;
	
-- Find out what Anchor Value to use
addonData["WatchFrame"].UseAnchor = function()
	if ( addonData["WatchFrame"].MultipleAnchors ) then
		if ( addonData["WatchFrame"].Collapsed ) then
			return addonData["WatchFrame"].CollapsedAnchor;
		else
			return addonData["WatchFrame"].ExpandedAnchor;
		end
	else
		-- Not Using Multiple Anchors ? Okay, let the calling function handle it
		return nil;
	end
end

---------------------------------------------------------------------
-- [v1.01.00] Additional Functionality if you collapse the WatchFrame
---------------------------------------------------------------------
addonData["WatchFrame"].CollapseExpand = function(self)		
	addonData["WatchFrame"].Collapsed = WatchFrame.collapsed or false;
end

addonData["WatchFrame"].RestoreWatchFrame = function()
	if ( addonData["WatchFrame"].Collapsed ) then 
		WatchFrame_Collapse(WatchFrame); 
	else
		WatchFrame_Expand(WatchFrame);
	end
end

addonData["WatchFrame"].ResetWatchFrame = function(parent)
	local f = WatchFrame;

	f:ClearAllPoints();
	f:SetClampedToScreen( false );
	f:SetParent(parent);
	f:SetWidth( parent:GetWidth() - 27.5 );
	f:SetPoint( "TOPLEFT", 27.5, 0 );
	f:SetPoint( "BOTTOMRIGHT", 0, 0 );
		
	f.ClearAllPoints = function() end;
	f.SetPoint = function() end;
	f.SetAllPoints = function() end;

	addonData["WatchFrame"].RestoreWatchFrame();
end
